diff -Nrup -x '*.orig' -x '*.rej' -x '*.*~' ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-zfs.h nautilus-2.30.1/libnautilus-private/nautilus-zfs.h
--- ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/libnautilus-private/nautilus-zfs.h	1970-01-01 01:00:00.000000000 +0100
+++ nautilus-2.30.1/libnautilus-private/nautilus-zfs.h	2010-05-14 17:17:27.383965864 +0200
@@ -0,0 +1,77 @@
+/* #include <config.h> */
+#ifndef NAUTILUS_ZFS_H
+#define NAUTILUS_ZFS_H
+
+#include <glib.h>
+#include <libzfs.h>
+#include <gio/gio.h>
+
+typedef struct 
+{
+  zfs_type_t	type;
+  zfs_prop_t	prop;
+  char	       *searched_path;
+  char         *mountpoint;
+  GList        *datasets;
+  GCancellable *cancel;
+  gboolean	match_found;
+  gboolean	searched_path_match_mp;
+
+} SearchDataSet;
+
+typedef struct
+{
+  char		  *name;	
+  char		  *mountpoint;	
+  char		  *mtime_str;
+  time_t	   mtime;
+  float		   used_space;
+  char		  *used_space_str;
+  zfs_type_t	   type;
+  GList		  *snapshots;
+  SearchDataSet	  *search_dataset;
+} ZfsDataSet;
+
+
+GList *ts_get_snapshots_for_dir_async	(GFile *file, 
+					 GAsyncReadyCallback result_ready, 
+					 GCancellable *cancel,
+					 gpointer  user_data);
+void ts_free_snapshots			(GList *snaps);
+void ts_free_zfs_dataset		(ZfsDataSet* zds);
+
+gboolean ts_is_in_snapshot		(char * str);
+gboolean ts_is_in_remote_backup		(char *str);
+char* ts_remove_snapshot_dir		(char *str);
+char *ts_get_snapshot_dir		(char *dir);
+char *ts_get_zfs_filesystem		(char *dir);
+char * ts_get_not_zfs_snapshot_dir      (GFile *file);
+gboolean ts_is_restore_column_enabled	();
+void ts_is_restore_column_enabled_init	();
+void print_snap_list			(char *dir, GList *snap_list);
+char* ts_realpath			(char * dir, char *resolved_name);
+
+char *
+nautilus_date_as_string			(time_t time_raw, gboolean use_smallest);
+
+typedef void (*ZfsDirChangeCallback)	(gpointer monitor_data, 
+					 gpointer user_data);
+
+typedef struct 
+{
+  char	*		path;
+  GList			*entries;
+  char	*		backup_path;
+  GList			*backup_entries;
+  guint			timeout_id;
+  ZfsDirChangeCallback	change_callback;
+  gpointer		user_data;
+} ZfsSnapDirMonitor;
+
+void monitor_zfs_snap_directory_cancel (ZfsSnapDirMonitor *monitor_data);
+ZfsSnapDirMonitor *monitor_zfs_snap_directory (char		    *path, 
+					       char		    *backup_path,
+					       ZfsDirChangeCallback change_callback,
+					       gpointer		    data);
+#endif /* NAUTILUS_ZFS_H */
+
--- nautilus-3.1.3/src/Makefile.am.orig	2011-07-01 17:50:32.000000000 +0100
+++ nautilus-3.1.3/src/Makefile.am	2011-07-22 10:47:37.617231822 +0100
@@ -41,6 +41,8 @@
 	$(EXIF_LIBS) \
 	$(EXEMPI_LIBS) \
 	$(POPT_LIBS) \
+	$(SCF_LIBS) \
+	$(NVPAIR_LIBS) \
 	$(NULL)
 
 nautilus_SOURCES = \
@@ -142,6 +144,10 @@
 	nautilus-window-types.h			\
 	nautilus-x-content-bar.c		\
 	nautilus-x-content-bar.h		\
+	nautilus-zfs-bar.c			\
+	nautilus-zfs-bar.h			\
+	timescale.c				\
+	timescale.h				\
 	$(NULL)
 
 EMPTY_VIEW_SOURCES = \
--- nautilus-3.1.3/src/nautilus-actions.h.orig	2011-07-22 10:54:06.075754016 +0100
+++ nautilus-3.1.3/src/nautilus-actions.h	2011-07-22 10:56:03.673858543 +0100
@@ -85,6 +85,9 @@
 #define NAUTILUS_ACTION_NEW_LAUNCHER "New Launcher"
 #define NAUTILUS_ACTION_NEW_LAUNCHER_DESKTOP "New Launcher Desktop"
 #define NAUTILUS_ACTION_RENAME "Rename"
+#define NAUTILUS_ACTION_RESTORE_TO "Restore to"
+#define NAUTILUS_ACTION_HAS_SNAPSHOT "View Snap"
+#define NAUTILUS_ACTION_SNAP_NOW "Snap Now"
 #define NAUTILUS_ACTION_DUPLICATE "Duplicate"
 #define NAUTILUS_ACTION_CREATE_LINK "Create Link"
 #define NAUTILUS_ACTION_SELECT_ALL "Select All"
--- nautilus-3.1.3/src/nautilus-view.c.orig	2011-07-25 14:46:18.267955464 +0100
+++ nautilus-3.1.3/src/nautilus-view.c	2011-07-25 14:45:21.541051018 +0100
@@ -1366,6 +1366,73 @@
 }
 
 static void
+action_snap_now (GtkAction *action,
+                 gpointer callback_data)
+{
+	NautilusView *view = NAUTILUS_VIEW (callback_data);
+	GList *selection = nautilus_view_get_selection_for_file_transfer (view);
+	GFile *file = nautilus_file_get_location (NAUTILUS_FILE (selection->data));
+	char *path = g_file_get_path (file);
+	char *fs = ts_get_zfs_filesystem (path);
+	char *cmd = g_strdup_printf ("/usr/lib/time-slider-snapshot '%s' '%s'", path, fs);
+        nautilus_launch_application_from_command (gtk_window_get_screen (GTK_WIDGET(callback_data)), cmd, FALSE, NULL);
+
+	g_free (cmd);
+	g_free (fs);
+	g_free (path);
+	g_object_unref (file);
+}
+
+static void
+action_restore_to_desktop_callback (GtkAction *action,
+                                    gpointer callback_data)
+{
+	GList *locations = NULL;
+	GList *node;
+	NautilusView *view = NAUTILUS_VIEW (callback_data);
+	char *desktop_directory = nautilus_get_desktop_directory_uri();
+	GList *selection = nautilus_view_get_selection_for_file_transfer (view);
+
+	if (selection == NULL)
+		return;
+
+	if (desktop_directory == NULL)
+		return;
+
+
+	for (node = selection; node != NULL; node = node->next) {
+		locations = g_list_prepend (locations,
+				nautilus_file_get_uri ((NautilusFile *) node->data));
+	}
+
+	nautilus_view_move_copy_items (locations, NULL, desktop_directory,
+				GDK_ACTION_COPY, 0, 0, view);
+
+	nautilus_file_list_free (selection);
+}
+
+static void
+action_show_snapshot_versions_callback (GtkAction *action,
+                                        gpointer callback_data)
+{
+	NautilusView *view = NAUTILUS_VIEW (callback_data);
+	GList *selection = nautilus_view_get_selection_for_file_transfer (view);
+	GFile *file = nautilus_file_get_location (NAUTILUS_FILE (selection->data));
+	char *dir = nautilus_file_get_snapshot_dir (NAUTILUS_FILE (selection->data));
+	char *file_path = g_file_get_path (file);
+	char real_file_path [PATH_MAX + 1];
+	if (ts_realpath (file_path, real_file_path)) {
+		char *cmd = g_strdup_printf ("/usr/lib/time-slider-version '%s' '%s'", dir,
+			real_file_path);
+                nautilus_launch_application_from_command (gtk_window_get_screen (GTK_WIDGET(callback_data)), cmd, FALSE, NULL);
+		g_free (cmd);
+	}
+
+	g_free (file_path);
+	g_object_unref (file);
+}
+
+static void
 action_trash_callback (GtkAction *action,
 		       gpointer callback_data)
 {
@@ -7076,6 +7143,24 @@
   /* label, accelerator */       "RenameSelectAll", "<shift>F2",
   /* tooltip */                  NULL,
 				 G_CALLBACK (action_rename_select_all_callback) },
+  /* name, stock id */         { "Restore to", NULL,
+  /* SUN_BRANDING */
+  /* label, accelerator */       N_("Restore to Desktop"), NULL,
+  /* SUN_BRANDING */
+  /* tooltip */                  N_("Move each selected item to the Desktop"),
+                                 G_CALLBACK (action_restore_to_desktop_callback) },
+  /* name, stock id */         { "View Snap", NULL,
+  /* SUN_BRANDING */
+  /* label, accelerator */       N_("View versions"), NULL,
+  /* SUN_BRANDING */
+  /* tooltip */                  N_("View the versions of this file available in ZFS snapshots"),
+                                 G_CALLBACK (action_show_snapshot_versions_callback) },
+  /* name, stock id */         { "Snap Now", NULL,
+  /* SUN_BRANDING */
+  /* label, accelerator */       N_("Snapshot now"), NULL,
+  /* SUN_BRANDING */
+  /* tooltip */                  N_("Take a ZFS snapshot of this directory now"),
+                                 G_CALLBACK (action_snap_now) },
   /* name, stock id */         { "Trash", NULL,
   /* label, accelerator */       N_("Mo_ve to Trash"), "<control>Delete",
   /* tooltip */                  N_("Move each selected item to the Trash"),
@@ -8294,6 +8379,41 @@
 	return FALSE;
 }
 
+typedef struct {
+  NautilusFile              *file;
+  GCancellable              *cancel;
+  GtkAction                 *action;
+} HasSnapshotData;
+
+static void
+has_snapshot_ready_callback (gpointer user_data)
+{
+  GValue name = {0,};
+  HasSnapshotData *data = (HasSnapshotData*) user_data;
+  HasSnapshotResult result = nautilus_file_has_snapshot_version (data->file);
+
+  switch (result)
+    {
+    case UNKNOWN_STATE:
+    case NO:
+      gtk_action_set_sensitive (data->action, FALSE);
+      g_value_init (&name, G_TYPE_STRING);
+      /* SUN_BRANDING */
+      g_value_set_static_string (&name, _("No versions"));
+      g_object_set_property (G_OBJECT (data->action), "label", &name);
+      break;
+    case YES:
+      gtk_action_set_sensitive (data->action, TRUE);
+      g_value_init (&name, G_TYPE_STRING);
+      /* SUN_BRANDING */
+      g_value_set_static_string (&name, _("Explore versions"));
+      g_object_set_property (G_OBJECT (data->action), "label", &name);
+      break;
+    }
+  g_free (data);
+ }
+
+
 static void
 real_update_menus (NautilusView *view)
 {
@@ -8609,6 +8729,74 @@
 					      NAUTILUS_ACTION_COPY);
 	gtk_action_set_sensitive (action, can_copy_files);
 
+        action = gtk_action_group_get_action (view->details->dir_action_group,
+                                              NAUTILUS_ACTION_RESTORE_TO);
+        gtk_action_set_visible (action, can_copy_files &&
+                                  nautilus_directory_is_in_snapshot (view->details->model));
+
+        action = gtk_action_group_get_action (view->details->dir_action_group,
+                                              NAUTILUS_ACTION_SNAP_NOW);
+
+        if (selection_count == 1 && nautilus_file_is_directory (NAUTILUS_FILE (selection->data)))
+            {
+              GFile *file = nautilus_file_get_location (NAUTILUS_FILE (selection->data));
+              char *path = g_file_get_path (file);
+              char *fs = ts_get_zfs_filesystem (path);
+              if (fs)
+                {
+                  gtk_action_set_visible (action, TRUE);
+                  g_free (fs);
+                }
+              g_free (path);
+              g_object_unref (file);
+            }
+        else
+          gtk_action_set_visible (action, FALSE);
+
+        action = gtk_action_group_get_action (view->details->dir_action_group,
+                                              NAUTILUS_ACTION_HAS_SNAPSHOT);
+   if (selection_count == 1)
+     {
+       GValue name = { 0, };
+       int result = nautilus_file_has_snapshot_version (NAUTILUS_FILE (selection->data));
+
+       switch (result)
+         {
+         case NO:
+           gtk_action_set_visible (action, FALSE);
+           break;
+         case YES:
+           gtk_action_set_visible (action, TRUE);
+           gtk_action_set_sensitive (action, TRUE);
+           g_value_init (&name,G_TYPE_STRING);
+           /* SUN_BRANDING */
+           g_value_set_static_string (&name, _("Explore versions"));
+           g_object_set_property (G_OBJECT (action), "label", &name);
+           break;
+         case UNKNOWN_STATE:
+           gtk_action_set_visible (action, TRUE);
+           gtk_action_set_sensitive (action, FALSE);
+           g_value_init (&name,G_TYPE_STRING);
+           /* SUN_BRANDING */
+           g_value_set_static_string (&name, _("Scanning for versions"));
+           g_object_set_property (G_OBJECT (action), "label", &name);
+           break;
+         }
+       if (result == UNKNOWN_STATE)
+         {
+           HasSnapshotData *data = g_new0 (HasSnapshotData, 1);
+           data->action = action;
+           data->file = NAUTILUS_FILE (selection->data);
+           data->cancel = g_cancellable_new ();
+           nautilus_file_get_snapshot_version (NAUTILUS_FILE (selection->data),
+                                               has_snapshot_ready_callback,
+                                               data->cancel,
+                                               data);
+         }
+     }
+   else
+     gtk_action_set_visible (action, FALSE);
+
 	real_update_paste_menu (view, selection, selection_count);
 
 	disable_command_line = g_settings_get_boolean (gnome_lockdown_preferences, NAUTILUS_PREFERENCES_LOCKDOWN_COMMAND_LINE);
diff -Nrup -x '*.orig' -x '*.rej' -x '*.*~' ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/src/nautilus-actions.h nautilus-2.30.1/src/nautilus-actions.h
--- ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/src/nautilus-actions.h	2010-01-22 16:45:17.000000000 +0100
+++ nautilus-2.30.1/src/nautilus-actions.h	2010-05-14 17:16:39.557199636 +0200
@@ -28,6 +28,7 @@
 
 #define NAUTILUS_ACTION_STOP "Stop"
 #define NAUTILUS_ACTION_RELOAD "Reload"
+#define NAUTILUS_ACTION_RESTORE "Restore"
 #define NAUTILUS_ACTION_BACK "Back"
 #define NAUTILUS_ACTION_UP "Up"
 #define NAUTILUS_ACTION_UP_ACCEL "UpAccel"
--- nautilus-3.1.3/src/nautilus-file-management-properties.c.orig	2011-04-25 18:02:09.000000000 +0100
+++ nautilus-3.1.3/src/nautilus-file-management-properties.c	2011-07-22 11:42:27.957358494 +0100
@@ -62,6 +62,7 @@
 #define NAUTILUS_FILE_MANAGEMENT_PROPERTIES_OPEN_NEW_WINDOW_WIDGET "new_window_checkbutton"
 #define NAUTILUS_FILE_MANAGEMENT_PROPERTIES_SHOW_HIDDEN_WIDGET "hidden_files_checkbutton"
 #define NAUTILUS_FILE_MANAGEMENT_PROPERTIES_TREE_VIEW_FOLDERS_WIDGET "treeview_folders_checkbutton"
+#define NAUTILUS_FILE_MANAGEMENT_PROPERTIES_ENABLE_TIME_SLIDER "time_slider_enabled_checkbutton"
 
 /* int enums */
 #define NAUTILUS_FILE_MANAGEMENT_PROPERTIES_THUMBNAIL_LIMIT_WIDGET "preview_image_size_combobox"
@@ -749,6 +750,10 @@
 			   NAUTILUS_FILE_MANAGEMENT_PROPERTIES_TREE_VIEW_FOLDERS_WIDGET,
 			   NAUTILUS_PREFERENCES_TREE_SHOW_ONLY_DIRECTORIES);
 
+	bind_builder_bool (builder, nautilus_tree_sidebar_preferences,
+			   NAUTILUS_FILE_MANAGEMENT_PROPERTIES_ENABLE_TIME_SLIDER,
+			   NAUTILUS_PREFERENCES_ENABLE_TIME_SLIDER);
+
 	bind_builder_enum (builder, nautilus_preferences,
 			   NAUTILUS_FILE_MANAGEMENT_PROPERTIES_DEFAULT_VIEW_WIDGET,
 			   NAUTILUS_PREFERENCES_DEFAULT_FOLDER_VIEWER,
--- nautilus-3.1.3/src/nautilus-window-manage-views.c.orig	2011-07-25 08:16:41.926463390 +0100
+++ nautilus-3.1.3/src/nautilus-window-manage-views.c	2011-07-25 08:49:32.039217259 +0100
@@ -39,6 +39,7 @@
 #include "nautilus-trash-bar.h"
 #include "nautilus-view-factory.h"
 #include "nautilus-x-content-bar.h"
+#include "nautilus-zfs-bar.h"
 #include <eel/eel-accessibility.h>
 #include <eel/eel-debug.h>
 #include <eel/eel-gdk-extensions.h>
@@ -50,6 +51,7 @@
 #include <gtk/gtk.h>
 #include <gdk/gdkx.h>
 #include <glib/gi18n.h>
+#include <stdlib.h>
 #include <libnautilus-extension/nautilus-location-widget-provider.h>
 #include <libnautilus-private/nautilus-file-attributes.h>
 #include <libnautilus-private/nautilus-file-utilities.h>
@@ -693,7 +695,9 @@
         NautilusFile *file;
 	gboolean force_reload;
         char *current_pos;
+	GFile *old_file = NULL;
 	GFile *from_folder, *parent;
+	NautilusWindow *window;
 
 	g_assert (slot != NULL);
         g_assert (location != NULL);
@@ -722,12 +726,43 @@
 
 	end_location_change (slot);
 
+	old_file = nautilus_window_slot_get_location (slot);
+	if (old_file) {
+		directory = nautilus_directory_get (old_file);
+		if (directory) {
+			nautilus_directory_cancel_restore_info (directory);
+			g_object_unref (directory);
+			directory = NULL;
+		}
+		g_object_unref (old_file);
+		old_file = NULL;
+	}
+
 	nautilus_window_slot_set_allow_stop (slot, TRUE);
 	nautilus_window_slot_set_status (slot, " ", NULL);
 
 	g_assert (slot->pending_location == NULL);
 	g_assert (slot->pending_selection == NULL);
 	
+	directory = nautilus_directory_get (location);
+
+	window = slot->pane->window;
+	g_assert (NAUTILUS_IS_WINDOW (window));
+	/* if snap and (ts is enabled and displayed )
+	 *  check if the directory exist
+	 *    if it doesn't move to the next available one */
+	 if (nautilus_directory_is_in_snapshot (directory) && is_time_slider_enabled ()) {
+		 if (gtk_widget_get_visible (window->details->zfs_bar)) {
+			char *path = g_file_get_path (location);
+			if (!g_file_test (path, G_FILE_TEST_IS_DIR)) {
+				nautilus_zfs_bar_remove_and_skip_snap (NAUTILUS_ZFS_BAR (window->details->zfs_bar), path);
+				g_free (path);
+				return;
+			}
+			g_free (path);
+		}
+	}
+
 	slot->pending_location = g_object_ref (location);
         slot->location_change_type = type;
         slot->location_change_distance = distance;
@@ -739,8 +774,6 @@
 	slot->open_callback = callback;
 	slot->open_callback_user_data = user_data;
 
-        directory = nautilus_directory_get (location);
-
 	/* The code to force a reload is here because if we do it
 	 * after determining an initial view (in the components), then
 	 * we end up fetching things twice.
@@ -919,8 +952,17 @@
 		/* If fallback, don't use view from metadata */
 		if (slot->location_change_type != NAUTILUS_LOCATION_CHANGE_FALLBACK) {
 			/* Look in metadata for view */
-			view_id = nautilus_file_get_metadata 
-				(file, NAUTILUS_METADATA_KEY_DEFAULT_VIEW, NULL);
+                   if (nautilus_file_is_in_snapshot (file))
+                     {
+                       NautilusDirectory* root_dir = nautilus_zfs_bar_get_dir (NAUTILUS_ZFS_BAR (window->details->zfs_bar));
+		       if (root_dir)
+			 view_id = nautilus_file_get_metadata (nautilus_directory_get_corresponding_file (root_dir), 
+							       NAUTILUS_METADATA_KEY_DEFAULT_VIEW, NULL);
+                     }
+                   if (view_id == NULL)
+                     view_id = nautilus_file_get_metadata
+                         (file, NAUTILUS_METADATA_KEY_DEFAULT_VIEW, NULL);
+
 			if (view_id != NULL && 
 			    !nautilus_view_factory_view_supports_uri (view_id,
 								      location,
@@ -1495,6 +1537,30 @@
 		/* Load menus from nautilus extensions for this location */
 		nautilus_window_load_extension_menus (window);
 	}
+		
+	/* time slider pref can be just enabled so we need 
+	 * to rescan for snapshots */
+	directory = nautilus_directory_get (slot->location);
+
+	if (window)
+	  {
+	    if (slot->find_zfs_snapshots_cancellable != NULL)
+	      {
+		g_cancellable_cancel (slot->find_zfs_snapshots_cancellable);
+		slot->find_zfs_snapshots_cancellable = NULL;
+	      }
+	    slot->find_zfs_snapshots_cancellable = g_cancellable_new ();
+	    nautilus_zfs_bar_display (NAUTILUS_ZFS_BAR (window->details->zfs_bar),
+				      window,
+				      directory,
+				      slot->find_zfs_snapshots_cancellable);
+
+	  }
+	else
+	  nautilus_window_allow_restore (window, FALSE);
+
+	nautilus_directory_unref (directory);
+
 
 	if (location_really_changed) {
 		nautilus_window_slot_remove_extra_location_widgets (slot);
@@ -1833,11 +1899,19 @@
 nautilus_window_slot_stop_loading (NautilusWindowSlot *slot)
 {
 	NautilusWindow *window;
+	NautilusDirectory *directory;
 
 	window = NAUTILUS_WINDOW (slot->pane->window);
 	g_assert (NAUTILUS_IS_WINDOW (window));
 
 	nautilus_view_stop_loading (slot->content_view);
+ 
+ 	if (slot->find_zfs_snapshots_cancellable)
+ 	  g_cancellable_cancel (slot->find_zfs_snapshots_cancellable);
+ 
+ 	directory = nautilus_directory_get (slot->location);
+ 	nautilus_directory_cancel_restore_info (directory);
+ 	nautilus_directory_unref (directory);
 	
 	if (slot->new_content_view != NULL) {
 		window->details->temporarily_ignore_view_signals = TRUE;
@@ -1898,6 +1972,8 @@
 		nautilus_window_disconnect_content_view (slot->pane->window, slot->content_view);
 	}
 
+	nautilus_window_slot_stop_loading (slot);
+
 	free_location_change (slot);
 	cancel_viewed_file_changed_callback (slot);
 }
--- nautilus-3.1.3/src/nautilus-window-menus.c.orig	2011-07-25 10:08:19.966466156 +0100
+++ nautilus-3.1.3/src/nautilus-window-menus.c	2011-07-25 10:08:46.797184803 +0100
@@ -40,6 +40,7 @@
 #include "nautilus-window-private.h"
 #include "nautilus-desktop-window.h"
 #include "nautilus-search-bar.h"
+#include "nautilus-zfs-bar.h"
 #include <gtk/gtk.h>
 #include <gio/gio.h>
 #include <glib/gi18n.h>
@@ -257,6 +258,33 @@
 }
 
 static void
+action_restore_callback (GtkToggleAction *action, 
+			gpointer user_data) 
+{
+  NautilusWindowSlot *slot;
+  GFile *directory;
+  NautilusDirectory *n_dir;
+  GtkWidget *bar = NAUTILUS_WINDOW (user_data)->details->zfs_bar;
+
+  slot = nautilus_window_get_active_slot (NAUTILUS_WINDOW (user_data));
+  directory = nautilus_window_slot_get_location (slot);
+  n_dir = nautilus_directory_get (directory);
+
+  if (gtk_toggle_action_get_active (action))
+    {
+      nautilus_zfs_bar_setup (NAUTILUS_ZFS_BAR (bar), n_dir, slot, action); 
+      gtk_widget_show (bar); 
+    }
+  else
+    {
+      nautilus_zfs_bar_hide (NAUTILUS_ZFS_BAR (bar));
+      nautilus_window_reload (NAUTILUS_WINDOW (user_data));
+    }
+  g_object_unref (n_dir);
+  g_object_unref (directory);
+}
+
+static void
 action_zoom_in_callback (GtkAction *action, 
 			 gpointer user_data) 
 {
@@ -1113,6 +1141,12 @@
 };
 
 static const GtkToggleActionEntry main_toggle_entries[] = {
+  /* name, stock id */         { "Restore", "stock_help",
+  /* SUN_BRANDING */
+  /* label, accelerator */       N_("R_estore"), "<control>E",
+  /* SUN_BRANDING */
+  /* tooltip */                  N_("Browse the current location snapshot history"),
+                                 G_CALLBACK (action_restore_callback) },
   /* name, stock id */         { "Show Hidden Files", NULL,
   /* label, accelerator */       N_("Show _Hidden Files"), "<control>H",
   /* tooltip */                  N_("Toggle the display of hidden files in the current window"),
diff -Nrup -x '*.orig' -x '*.rej' -x '*.*~' ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/src/nautilus-window-slot.c nautilus-2.30.1/src/nautilus-window-slot.c
--- ../SUNWgnome-file-mgr-2.30.0-b4/nautilus-2.30.1/src/nautilus-window-slot.c	2009-12-16 17:53:51.000000000 +0100
+++ nautilus-2.30.1/src/nautilus-window-slot.c	2010-05-14 17:16:39.566465378 +0200
@@ -650,6 +650,13 @@ nautilus_window_slot_dispose (GObject *o
 		slot->find_mount_cancellable = NULL;
 	}
 
+ 	if (slot->find_zfs_snapshots_cancellable)
+ 	  {
+ 	    g_cancellable_cancel (slot->find_zfs_snapshots_cancellable);
+ 	    g_object_unref (slot->find_zfs_snapshots_cancellable);
+ 	    slot->find_zfs_snapshots_cancellable = NULL;
+ 	  }
+
 	slot->pane = NULL;
 
 	g_free (slot->title);
--- nautilus-3.1.3/src/nautilus-window-slot.h.orig	2011-06-28 14:41:41.000000000 +0100
+++ nautilus-3.1.3/src/nautilus-window-slot.h	2011-07-22 14:33:49.936636702 +0100
@@ -113,6 +113,7 @@
 	gpointer open_callback_user_data;
 
 	GCancellable *find_mount_cancellable;
+	GCancellable *find_zfs_snapshots_cancellable;
 
 	gboolean visible;
 
--- nautilus-3.1.3/src/nautilus-window.c.orig	2011-07-25 14:28:16.524301501 +0100
+++ nautilus-3.1.3/src/nautilus-window.c	2011-07-25 14:28:29.183307666 +0100
@@ -44,6 +44,7 @@
 #include "nautilus-window-manage-views.h"
 #include "nautilus-window-bookmarks.h"
 #include "nautilus-window-slot.h"
+#include "nautilus-zfs-bar.h"
 
 #include <eel/eel-debug.h>
 #include <eel/eel-gtk-extensions.h>
@@ -95,6 +96,7 @@
 static void mouse_back_button_changed		     (gpointer                  callback_data);
 static void mouse_forward_button_changed	     (gpointer                  callback_data);
 static void use_extra_mouse_buttons_changed          (gpointer                  callback_data);
+static void restore_pref_changed                     (gpointer                  callback_data);
 
 /* Sanity check: highest mouse button value I could find was 14. 5 is our 
  * lower threshold (well-documented to be the one of the button events for the 
@@ -269,6 +271,18 @@
 	gtk_action_set_sensitive (action, allow);
 }
 
+void
+nautilus_window_allow_restore (NautilusWindow *window, gboolean enable)
+{
+	GtkAction *action;
+
+	g_assert (NAUTILUS_IS_WINDOW (window));
+
+	action = gtk_action_group_get_action (window->details->main_action_group,
+					      NAUTILUS_ACTION_RESTORE);
+	gtk_action_set_sensitive (action, enable);
+}
+
 static void
 update_cursor (NautilusWindow *window)
 {
@@ -277,7 +291,7 @@
 
 	slot = window->details->active_pane->active_slot;
 
-	if (slot->allow_stop) {
+	if (slot && slot->allow_stop) {
 		cursor = gdk_cursor_new (GDK_WATCH);
 		gdk_window_set_cursor (gtk_widget_get_window (GTK_WIDGET (window)), cursor);
 		g_object_unref (cursor);
@@ -303,8 +317,14 @@
 	if (slot != window->details->active_pane->active_slot ||
 	    allow_stop != slot->allow_stop) {
 		if (slot == window->details->active_pane->active_slot) {
-			gtk_action_set_sensitive (action, slot->allow_stop);
-		}
+			if (!slot->allow_stop && slot->find_zfs_snapshots_cancellable != NULL) { 
+			/* if slot want to stop and snap find is finished/cancel then disable */
+				if (g_cancellable_is_cancelled (slot->find_zfs_snapshots_cancellable))
+					gtk_action_set_sensitive (action, slot->allow_stop);
+			} else {
+				gtk_action_set_sensitive (action, slot->allow_stop);
+                	}
+                }
 
 		if (gtk_widget_get_realized (GTK_WIDGET (window))) {
 			update_cursor (window);
@@ -575,7 +595,7 @@
 
 	G_OBJECT_CLASS (nautilus_window_parent_class)->constructed (self);
 
-	table = gtk_table_new (1, 6, FALSE);
+	table = gtk_table_new (1, 7, FALSE);
 	window->details->table = table;
 	gtk_widget_show (table);
 	gtk_container_add (GTK_CONTAINER (window), table);
@@ -592,6 +612,7 @@
 	menu = gtk_ui_manager_get_widget (window->details->ui_manager, "/MenuBar");
 	window->details->menubar = menu;
 	gtk_widget_show (menu);
+
 	gtk_table_attach (GTK_TABLE (table),
 			  menu, 
 			  /* X direction */                   /* Y direction */
@@ -607,7 +628,7 @@
 	gtk_table_attach (GTK_TABLE (window->details->table),
 			  window->details->content_paned,
 			  /* X direction */                   /* Y direction */
-			  0, 1,                               3, 4,
+			  0, 1,                               4, 5,
 			  GTK_EXPAND | GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_FILL | GTK_SHRINK,
 			  0,                                  0);
 	gtk_widget_show (window->details->content_paned);
@@ -632,6 +653,15 @@
 				      nautilus_window_disable_chrome_mapping, NULL,
 				      window, NULL);
 
+	/* add custom icon */
+
+	nautilus_window_set_restore_icon (window, RESTORE_SEARCH);
+	/* add preference callback */
+	g_signal_connect_swapped (nautilus_preferences,
+				  "changed::" NAUTILUS_PREFERENCES_ENABLE_TIME_SLIDER,
+				  G_CALLBACK(restore_pref_changed),
+				  (gpointer) window);
+
 	pane = nautilus_window_pane_new (window);
 	window->details->panes = g_list_prepend (window->details->panes, pane);
 
@@ -656,6 +686,15 @@
 	slot = nautilus_window_open_slot (window->details->active_pane, 0);
 	nautilus_window_set_active_slot (window, slot);
 	nautilus_window_menus_lockdown_notify_add (window);
+
+	window->details->zfs_bar = nautilus_zfs_bar_new ();
+
+	gtk_table_attach (GTK_TABLE (NAUTILUS_WINDOW (window)->details->table),
+			  window->details->zfs_bar,
+			  /* X direction */                    /* Y direction */
+			  0, 1,                                3, 4,
+			  GTK_EXPAND | GTK_FILL | GTK_SHRINK,  0,
+			  0,                                   0);
 }
 
 static void
@@ -1913,7 +1952,7 @@
 	return slot;
 }
 
-static void
+void
 nautilus_window_reload (NautilusWindow *window)
 {
 	NautilusWindowSlot *active_slot;
@@ -1997,6 +2036,13 @@
 }
 
 static void
+restore_pref_changed (gpointer callback_data)
+{
+	g_assert (NAUTILUS_IS_WINDOW (callback_data));
+	nautilus_window_reload (NAUTILUS_WINDOW(callback_data));
+}
+
+static void
 mouse_back_button_changed (gpointer callback_data)
 {
 	int new_back_button;
@@ -2030,7 +2076,6 @@
 	mouse_extra_buttons = g_settings_get_boolean (nautilus_preferences, NAUTILUS_PREFERENCES_MOUSE_USE_EXTRA_BUTTONS);
 }
 
-
 /*
  * Main API
  */
@@ -2249,3 +2294,47 @@
 {
 	return g_list_length (NAUTILUS_WINDOW (window)->details->panes) > 1;
 }
+
+void nautilus_window_set_restore_icon (NautilusWindow* window,
+				       NautilusRestoreIconType type)
+{
+	static gboolean init = 0;
+	static GdkPixbuf *normal = NULL;
+	static GdkPixbuf *search = NULL;
+	static GdkPixbuf *no = NULL;
+	GdkPixbuf *pb = NULL;
+	GtkWidget *image = NULL;
+	GtkAction* action = gtk_ui_manager_get_action (nautilus_window_get_ui_manager (NAUTILUS_WINDOW (window)), "/Toolbar/Restore");
+
+	if (!init) {
+		char *path = nautilus_pixmap_file ("restore.png");
+		normal = gdk_pixbuf_new_from_file (path, NULL);
+		g_free (path);
+		path = nautilus_pixmap_file ("restore-search.png");
+		search = gdk_pixbuf_new_from_file (path, NULL);
+		g_free (path);
+		init = TRUE;
+	}
+
+	switch (type) {
+	case RESTORE_NORMAL :
+		pb = normal;
+		break;
+	case RESTORE_SEARCH:
+		pb = search;
+		break;
+	case RESTORE_NO:
+		pb = no;
+		break;
+	}
+
+	image = gtk_image_new_from_pixbuf (pb);
+	g_object_ref (image);
+	gtk_widget_show (image);
+	GSList *tmp = gtk_action_get_proxies (action);
+	for (tmp; tmp ; tmp = tmp->next) {
+		GtkWidget *proxy = (GtkWidget *)tmp->data;
+		if (GTK_IS_TOOL_BUTTON (proxy))
+			gtk_tool_button_set_icon_widget (GTK_TOOL_BUTTON (proxy), image);
+	}
+}
--- nautilus-3.1.3/src/nautilus-window-private.h.orig	2011-07-25 10:54:12.777383655 +0100
+++ nautilus-3.1.3/src/nautilus-window-private.h	2011-07-25 11:06:58.227055497 +0100
@@ -94,6 +94,8 @@
         GtkWidget *sidebar;
         gchar *sidebar_id;
         
+        GtkWidget *zfs_bar;
+
         /* Toolbar */
         GtkWidget *toolbar;
 
@@ -111,6 +113,12 @@
         guint sidebar_width_handler_id;
 };
 
+typedef enum {
+	RESTORE_NORMAL,
+	RESTORE_SEARCH,
+	RESTORE_NO
+} NautilusRestoreIconType;
+
 /* window geometry */
 /* Min values are very small, and a Nautilus window at this tiny size is *almost*
  * completely unusable. However, if all the extra bits (sidebar, location bar, etc)
@@ -176,6 +184,9 @@
 void               nautilus_window_update_show_hide_menu_items           (NautilusWindow     *window);
 void               nautilus_window_menus_lockdown_notify_add             (NautilusWindow    *window);
 void               nautilus_window_menus_lockdown_notify_remove          (NautilusWindow    *window);
+gboolean           nautilus_window_zfs_bar_showing                       (NautilusWindow    *window);
+void               nautilus_window_set_restore_icon                      (NautilusWindow    *window,
+                                                                          NautilusRestoreIconType type);
 
 /* window toolbar */
 void               nautilus_window_close_pane                            (NautilusWindowPane *pane);
--- nautilus-3.1.3/src/nautilus-window.h.orig	2011-06-28 14:41:41.000000000 +0100
+++ nautilus-3.1.3/src/nautilus-window.h	2011-07-22 14:56:24.534238012 +0100
@@ -152,6 +152,8 @@
                                                gboolean       allow);
 void     nautilus_window_allow_forward        (NautilusWindow *window,
                                                gboolean        allow);
+void     nautilus_window_allow_restore        (NautilusWindow *window,
+                                               gboolean        allow);
 void     nautilus_window_clear_back_list      (NautilusWindow *window);
 void     nautilus_window_clear_forward_list   (NautilusWindow *window);
 void     nautilus_forget_history              (void);
